#include <iostream.h>
#include <graphics.h>
#include <conio.h>

unsigned long figures[7][3] = {{0x240201,0,0},
                               {0x402,2,0},
                               {0x603618,0,0},
                               {4,0x804,0x800},
                               {0x5A05,0xA00,0},
                               {0x6030,0x6C00,0},
                               {0x7000,0x7E07,0}};

int X[7] = {2,3,2,3,2,2,2};
int Y[7] = {1,2,1,2,2,2,2};
int Z[7] = {3,2,3,1,2,2,2};

int RX[7] = {4,4,2,2,4,4,4};
int RY[7] = {2,2,2,2,4,4,4};
int RZ[7] = {4,2,4,2,4,4,4};

unsigned long plane[3] = {0,0,0};

int main_x = 50, main_y = 50;

bool Add(int x, int y, int z, unsigned long d[3])
{
  for (int zz = z; zz < 3; zz++)
    for (int yy = y; yy < 3; yy++)
      for (int xx = x; xx < 3; xx++)
      {
        int a = ((plane[zz] >> (yy * 9)) >> (xx * 3)) & 7;
        int b = ((d[zz - z] >> ((yy - y) * 9)) >> ((xx - x) * 3)) & 7;
        if (b && a) return false;
      }

  for (int i = 0; i < 3 - z; i++)
    plane[i + z] += (d[i] << (x * 3)) << (y * 9);

  return true;
}

void Del(int x, int y, int z, unsigned long d[3])
{
  for (int i = 0; i < 3 - z; i++)
    plane[i + z] ^= (d[i] << (x * 3)) << (y * 9);
}

void Rotate(char dir, unsigned long d[3])
{
  unsigned long p[3] = {0,0,0};
  unsigned long q;
  char u;
  int x, y, z, i;

  switch (dir)
  {
    case 'x': break;
    case 'y': break;
    case 'z': for (z = 0; z < 3; z++)
              {
                for (y = 0; y < 3; y++)
                  for (x = 0; x < 3; x++)
                  {
                    u = d[z] & 7;
                    if (u)
                      p[z] |= ((long)u << ((2 - x) * 9)) << (y * 3);
                    d[z] >>= 3;
                  }
                d[z] = p[z];
              }
              for (i = 0; i < 2; i++)
              {
                q = 0;
                for (int z = 0; z < 3; z++)
                  q += d[z] & 511;
                if (!q)
                for (int z = 0; z < 3; z++)
                  d[z] >>= 9;
              }
  }
}

void DrawCube(int x, int y, int z, char color, bool wire)
{
  int xx, yy;

  xx = main_x + x * 12;
  xx += 12 * y;
  yy = main_y - x * 4;
  yy += 4 * y;
  yy += z * 12;

  int poly1[] = {xx, yy, xx + 12, yy - 4, xx + 12, yy + 8, xx, yy + 12, xx, yy};
  int poly2[] = {xx, yy, xx - 12, yy - 4, xx - 12, yy + 8, xx, yy + 12, xx, yy};
  int poly3[] = {xx, yy, xx - 12, yy - 4, xx, yy - 8, xx + 12, yy - 4, xx, yy};

  if (!wire)
  {
    setcolor(0);
    setfillstyle(1, color);
    fillpoly(5, poly1);
    setfillstyle(1, color);
    fillpoly(5, poly2);
    setfillstyle(1, color);
    fillpoly(5, poly3);
  }
  else
  {
    setcolor(8);
    setfillstyle(1, 0);
    drawpoly(5, poly1);
    drawpoly(5, poly2);
    drawpoly(5, poly3);
  }
}

void Draw(unsigned long d[3])
{
  for (int z = 2; z >= 0; z--)
    for (int y = 0; y < 3; y++)
      for (int x = 2; x >= 0; x--)
      {
        int a = ((d[z] >> (3 * x)) >> (9 * y)) & 7;
        if (a)
          DrawCube(x, y, z, a, false);
        else
          DrawCube(x, y, z, a, true);
      }

  main_x += 80;
  if (main_x > 560)
  {
    main_x = 50;
    main_y += 80;
    if (main_y > 400)
    {
      cleardevice();
      main_y = 50;
    }
  }
}

void Build(int iter)
{
  for (int rz = 0; rz < RZ[iter]; rz++)
  {
    for (int x = 0; x < X[iter]; x++)
      for (int y = 0; y < Y[iter]; y++)
        for (int z = 0; z < Z[iter]; z++)
        {
          if (Add(x, y, z, figures[iter]))
          {
            if (iter == 4)
              Draw(plane);
            else
              Build(iter + 1);
            Del(x, y, z, figures[iter]);
          }
        }
    if (!iter) break;
    X[iter] ^= Y[iter];
    Y[iter] ^= X[iter];
    X[iter] ^= Y[iter];
    Rotate('z', figures[iter]);
  }
}

void main()
{
  int gd = DETECT, gm;

  registerbgidriver(EGAVGA_driver);
  initgraph(&gd, &gm, "");

/*  Draw(figures[0]);
  Rotate('z', figures[0]);
  Draw(figures[0]);
  Rotate('z', figures[0]);
  Draw(figures[0]);
  Rotate('z', figures[0]);
  Draw(figures[0]); */

  Build(0);

  getch();
  closegraph();
}
