#include <fstream.h>
#include <strstrea.h>
#include <string.h>

struct Fig {
  unsigned long data[3];
  int x, y, z;
  Fig *next;
} *beg = NULL, *end = NULL;

void Add(char *s)
{
  Fig *f = new Fig;

  f -> z = 0;
  for (int i = 0; i < 3; i++)
  {
    f -> data[i] = 0;
    for (int j = 0; j < 9; j++)
    {
      if (s[i * 9 + j] != '0')
        f -> data[i] |= (unsigned long)(s[i * 9 + j] - 'a' + 1) << (j * 3);
    }
    if (!f -> data[i]) f -> z++;
  }
  f -> z++;

  f -> y = 0;
  for (i = 0; i < 3; i++)
  {
    int q = 0;
    for (int j = 0; j < 3; j++)
      if ((f -> data[j] >> (i * 9)) & 511) q++;
    if (!q) f -> y++;
  }
  f -> y++;

  f -> x = 0;
  for (i = 0; i < 3; i++)
  {
    int q = 0;
    for (int j = 0; j < 3; j++)
      if ((f -> data[j] >> (i * 3)) & 0x1C0E07UL) q++;
    if (!q) f -> x++;
  }
  f -> x++;

  if (beg == NULL)
    beg = f;
  else
    end -> next = f;
  end = f;
}

void Read(char *filename)
{
  ifstream in(filename);
  char s[28];

  while (in)
  {
    in >> s;
    if (!s[0]) continue;
    Add(s);
  }

  in.close();
}

ofstream& operator <<(ofstream& o, Fig f)
{
  o << "{{";
  for (int i = 0; i < 3; i++)
  {
    o << hex;
    o << "0x" << f.data[i];
    if (i < 2) o << ",";
  }
  o << "}," << f.x;
  o << "," << f.y;
  o << "," << f.z;
  o << "};\n";

  return o;
}

void Write(char *filename)
{
  ofstream out(filename);
  Fig *f = beg;

  while (f != NULL)
  {
    out << *f;
    f = f -> next;
  }

  out.close();
}

void main(int argc, char **argv)
{
  if (argc < 2) return;
  char name[13];

  Read(argv[1]);
  istrstream(argv[1]).getline(name, 8, '.');
  strcat(name, ".h");
  Write(name);
}
