#include <graphics.h>
#include <fstream.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>
#include "figures.h"

const unsigned long ITERATIONS = 45978574;

unsigned long plane[3] = {0,0,0};
unsigned long iters = 0;
int main_x = 50, main_y = 50;
int solutions = 0;
long t = clock();
int x = 1;

ofstream out("out.txt");

bool Add(int x, int y, int z, unsigned long d[3])
{
  for (int zz = z; zz < 3; zz++)
  {
    unsigned long u = (plane[zz] >> (y * 9)) >> (x * 3);
    unsigned long v = d[zz - z];
    for (int i = 0; i < 8; i++)
    {
      if ((u & 7) && (v & 7)) return false;
      u >>= 3;
      v >>= 3;
    }
  }

  for (int i = 0; i < 3 - z; i++)
    plane[i + z] |= (d[i] << (x * 3)) << (y * 9);

  return true;
}

void Del(int x, int y, int z, unsigned long d[3])
{
  for (int i = 0; i < 3 - z; i++)
    plane[i + z] ^= (d[i] << (x * 3)) << (y * 9);
}

void Print()
{
  unsigned long u = clock() / CLK_TCK;
  int h = u / 3600;
  int m = (u - h * 3600) / 60;
  int s = u - (h * 3600 + m * 60);
  cout << "\nProgram time: ";
  cout.fill('0');
  cout.width(2);
  cout << h;
  cout << ':';
  cout.width(2);
  cout << m;
  cout << ':';
  cout.width(2);
  cout << s;
  cout << '\n';
  cout << solutions << " solutions found\n";
  cout << iters << " iterations\n";
  out.close();
  _setcursortype(_NORMALCURSOR);
}

void Count(unsigned long n)
{
  if (!(iters % 1000000))
  {
    cout << '';
    x = wherex();
  }

  if (!(iters % 0x10000))
  {
    gotoxy(47, wherey());
    cout << (int)((double)iters / ITERATIONS * 100) << "%  ";
    cout << n << '/' << ITERATIONS;
    gotoxy(x, wherey());
    if (kbhit())
    {
      cout << "\n\nUser break\n";
      Print();
      exit(1);
    }
  }
}

void Encode()
{
  for (int y = 2; y >= 0; y--)
    for (int z = 0; z < 3; z++)
      for (int x = 0; x < 3; x++)
      {
        int a = ((plane[z] >> (y * 9)) >> (x * 3)) & 7;
        if (a)
          out << (char)(a + '`');
        else
          out << '0';
      }

  out << '\n';
}

void Build(int iter)
{
  for (int i = 0; i < 12; i++)
  {
    int a = figures[iter][i].z;
    int b = figures[iter][i].y;
    int c = figures[iter][i].x;
    for (int z = 0; z < a; z++)
      for (int y = 0; y < b; y++)
        for (int x = 0; x < c; x++)
        {
          iters++;
          Count(iters);
          if (Add(x, y, z, figures[iter][i].data))
          {
            if (iter == 6)
            {
              solutions++;
              Encode();
            }
            else
              Build(iter + 1);
            Del(x, y, z, figures[iter][i].data);
          }
        }
    if (!iter) break;
    if ((iter == 4) && (i == 7)) break;
  }
}

void main()
{
  _setcursortype(_NOCURSOR);
  cout << '\n';
  for (int i = 0; i < 45; i++)
    cout << '';
  gotoxy(1, wherey());
  Build(0);
  cout << '\n';
  Print();
}
