#include <fstream.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>
#include "figures.h"

#define  bool   int
#define  false  0
#define  true   1

unsigned long plane[3] = {0UL,0UL,0UL};
unsigned long iters = 0UL;
int solutions = 0;
long t = clock();

ofstream out("out.txt");

bool Add(int x, int y, int z, unsigned long d[3])
{
  int g = y * 9 + x * 3;
  for (int zz = z; zz < 3; zz++)
  {
    unsigned long u = plane[zz] >> g;
    unsigned long v = d[zz - z];
    for (int i = 0; i < 8; i++)
    {
      if ((u & 7) && (v & 7)) return false;
      u >>= 3;
      v >>= 3;
    }
  }

  for (int i = 0; i < 3 - z; i++)
    plane[i + z] |= d[i] << g;

  return true;
}

void Del(int x, int y, int z, unsigned long d[3])
{
  int g = y * 9 + x * 3;
  for (int i = 0; i < 3 - z; i++)
    plane[i + z] ^= d[i] << g;
}

void Print()
{
  unsigned long u = clock() / CLK_TCK;
  unsigned long h = u / 3600;
  unsigned long m = (u - h * 3600) / 60;
  unsigned long s = u - (h * 3600 + m * 60);
  cout << "\nProgram time: ";
  cout.fill('0');
  cout.width(2);
  cout << h;
  cout << ':';
  cout.width(2);
  cout << m;
  cout << ':';
  cout.width(2);
  cout << s;
  cout << '\n';
  cout << solutions << " solutions found\n";
  cout << iters << " iterations\n";
  out.close();
}

inline void Count()
{
  if (!(iters % 0x10000UL))
  {
    if (kbhit())
    {
      cout << "\nUser break\n";
      Print();
      exit(1);
    }
  }
}

void Encode()
{
  cout << solutions << ". ";
  for (int y = 2; y >= 0; y--)
    for (int z = 0; z < 3; z++)
      for (int x = 0; x < 3; x++)
      {
        unsigned long a = ((plane[z] >> (y * 9)) >> (x * 3)) & 7;
        if (a)
        {
          out << (char)(a + '`');
          cout << (char)(a + '`');
        }
        else
        {
          out << '0';
          cout << '0';
        }
      }

  out << '\n';
  cout << '\n';
}

void Build(int iter)
{
  for (int i = 0; i < 12; i++)
  {
    int a = figures[iter][i].z;
    int b = figures[iter][i].y;
    int c = figures[iter][i].x;
    for (int z = 0; z < a; z++)
      for (int y = 0; y < b; y++)
        for (int x = 0; x < c; x++)
        {
          iters++;
          Count();
          if (Add(x, y, z, figures[iter][i].data))
          {
            if (iter == 6)
            {
              solutions++;
              Encode();
            }
            else
              Build(iter + 1);
            Del(x, y, z, figures[iter][i].data);
          }
        }
    if (!iter) break;
    if ((iter == 4) && (i == 7)) break;
  }
}

void main()
{
  Build(0);
  Print();
}
